﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Spread_Win_DataSource
{
    public partial class BindCellRange : Form
    {
        public BindCellRange()
        {
            InitializeComponent();
        }

        private void btnBindCellRange_Click(object sender, EventArgs e)
        {
            var dt = GetDataTable();
            int dtRowCount = dt.Rows.Count;

            this.fpSpread1.ActiveSheet.Rows.Add(4, dtRowCount);

            //通过 SpreadDataBindingAdapter 实现单元格范围的数据绑定
            FarPoint.Win.Spread.Data.SpreadDataBindingAdapter data = new FarPoint.Win.Spread.Data.SpreadDataBindingAdapter();

            //设置数据源
            data.DataSource = dt;
            
            //设置相应的 Spread 和 Sheet 对象
            data.Spread = fpSpread1;
            data.SheetName = "Sheet1";

            //设置对应的单元格范围
            data.MapperInfo = new FarPoint.Win.Spread.Data.MapperInfo(4, 0, dt.Rows.Count, dt.Columns.Count);

            //绑定数据
            data.FillSpreadDataByDataSource();

            SetSheetFormat(dtRowCount);
        }

        private void SetSheetFormat(int rowCount)
        {
            for (int i = 0; i <rowCount ; i++)
            {
                this.fpSpread1.Sheets[0].Rows[4 + i].Height = 35;
                this.fpSpread1.Sheets[0].Rows[4 + i].Border = new FarPoint.Win.LineBorder(Color.Black, 1, true, true, true, true);
            }

            this.fpSpread1.Sheets[0].Columns[0].MergePolicy = FarPoint.Win.Spread.Model.MergePolicy.Always;
            this.fpSpread1.AllowUserFormulas = true;
        }

        /// <summary>
        /// 获取数据源
        /// </summary>
        /// <returns></returns>
        private static DataTable GetDataTable()
        {

            System.Data.DataTable dt = new System.Data.DataTable();
            dt.Columns.Add("部门");
            dt.Columns.Add("姓名");
            dt.Columns.Add("参加工作时间");
            dt.Columns.Add("学历");
            dt.Columns.Add("工资", typeof(int));
            dt.Columns.Add("话费补贴", typeof(int));
            dt.Columns.Add("伙食补贴", typeof(int));
            dt.Columns.Add("其它", typeof(int));
            dt.Columns.Add("间");

            dt.Rows.Add("业务部","王晨光", "1979-12", "大学专科毕业生", null, 2583, 3894, null, "2013-03");
            dt.Rows.Add("业务部", "吴成龙", "1979-12", "大学专科毕业生", null, null, null, null, "2013-03");

            dt.Rows.Add("研发部", "李晶莹", "2000-03", "大学本科毕业生", 760, 2583, 3453, null, "2013-03");
            dt.Rows.Add("研发部", "胡明辉", "2000-03", "大学本科毕业生", null, null, null, null, "2013-03");

            dt.Rows.Add("研发部", "张冬玲", "2005-08", "硕士研究生", 4650, null, 3453, null, "2013-03");
            dt.Rows.Add("研发部", "赵启成", "2005-08", "硕士研究生", null, null, null, null, "2013-03");

            dt.Rows.Add("管理部", "钱阳春", "1988-01", "博士研究生", 1760, 5800, 3692, 425, "2013-03");
            dt.Rows.Add("管理部", "冯景阳", "1988-01", "博士研究生", 1560, null, null, null, "2013-03");

            dt.Rows.Add("管理部", "田耕", "2001-07", "硕士研究生", 1563, 2583, 1025, null, "2013-03");
            dt.Rows.Add("财务部", "郝时光", "2001-07", "硕士研究生", 2788, null, 1255, null, "2013-03");

            dt.Rows.Add("财务部", "王德国", "2008-12", "大学本科毕业生", 2500, 2456, 3562, null, "2013-03");
            dt.Rows.Add("财务部", "周丹", "2008-12", "大学本科毕业生", null, 6500, null, 2580, "2013-03");

            return dt;
        }

        private void btnLoadExcel_Click(object sender, EventArgs e)
        {
            string filename =System.IO.Path.Combine(Application.StartupPath, "..\\..\\data\\template.xlsx");
            fpSpread1.OpenExcel(filename, FarPoint.Excel.ExcelOpenFlags.TruncateEmptyRowsAndColumns);
        }
    }
}
