﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Spread_Win_DataSource
{
    public partial class BindColumn : Form
    {
        public BindColumn()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 获取数据源
        /// </summary>
        /// <returns></returns>
        private static DataTable GetDataTable()
        {

            System.Data.DataTable dt = new System.Data.DataTable();
            dt.Columns.Add("部门");
            dt.Columns.Add("姓名");
            dt.Columns.Add("参加工作时间");
            dt.Columns.Add("学历");
            dt.Columns.Add("工资", typeof(int));
            dt.Columns.Add("话费补贴", typeof(int));
            dt.Columns.Add("伙食补贴", typeof(int));
            dt.Columns.Add("其它", typeof(int));

            dt.Rows.Add("业务部", "王晨光", "1979-12", "大学专科毕业生", null, 2583, 3894, null);
            dt.Rows.Add("业务部", "吴成龙", "1979-12", "大学专科毕业生", null, null, null, null);

            dt.Rows.Add("研发部", "李晶莹", "2000-03", "大学本科毕业生", 760, 2583, 3453, null);
            dt.Rows.Add("研发部", "胡明辉", "2000-03", "大学本科毕业生", null, null, null, null);

            dt.Rows.Add("研发部", "张冬玲", "2005-08", "硕士研究生", 4650, null, 3453, null);
            dt.Rows.Add("研发部", "赵启成", "2005-08", "硕士研究生", null, null, null, null);

            dt.Rows.Add("管理部", "钱阳春", "1988-01", "博士研究生", 1760, 5800, 3692, 425);
            dt.Rows.Add("管理部", "冯景阳", "1988-01", "博士研究生", 1560, null, null, null);

            dt.Rows.Add("管理部", "田耕", "2001-07", "硕士研究生", 1563, 2583, 1025, null);
            dt.Rows.Add("财务部", "郝时光", "2001-07", "硕士研究生", 2788, null, 1255, null);

            dt.Rows.Add("财务部", "王德国", "2008-12", "大学本科毕业生", 2500, 2456, 3562, null);
            dt.Rows.Add("财务部", "周丹", "2008-12", "大学本科毕业生", null, 6500, null, 2580);

            return dt;
        }

        private void btnBindColumn_Click(object sender, EventArgs e)
        {
            var dt = GetDataTable();

            //关闭自动生成列属性
            fpSpread1.Sheets[0].AutoGenerateColumns = false;

            //绑定数据源
            fpSpread1.DataSource = dt;

            //指定特定列字段
            fpSpread1.Sheets[0].Columns[0].DataField = "姓名";
            fpSpread1.Sheets[0].Columns[2].DataField = "参加工作时间";
            fpSpread1.Sheets[0].Columns[3].DataField = "工资";
            fpSpread1.Sheets[0].Columns[4].DataField = "学历";
            fpSpread1.Sheets[0].Columns[5].DataField = "部门";
        }

        private void btnSetCellType_Click(object sender, EventArgs e)
        {
            //设置售价列数据源
            var curCellType = new FarPoint.Win.Spread.CellType.CurrencyCellType() {SpinButton=true};
            fpSpread1.Sheets[0].Columns[3].CellType = curCellType;

            //置日期列数据源
            var dateCellType = new FarPoint.Win.Spread.CellType.DateTimeCellType() { DropDownButton = true };
            fpSpread1.Sheets[0].Columns[2].CellType = dateCellType;
        }
    }
}
