﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using System.Data.OleDb;

namespace Spread_Win_DataSource
{
public partial class HandleData : Form
    {
        static string ConnStr = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\data\NWind_CHS.mdb;Persist Security Info=True";

        public HandleData()
        {
            InitializeComponent();
        }

        SheetView _sv;
        private void HandleData_Load(object sender, EventArgs e)
        {
            // TODO: 这行代码将数据加载到表“nWind_CHSDataSet1.订单”中。您可以根据需要移动或删除它。
            this.订单TableAdapter.Fill(this.nWind_CHSDataSet1.订单);
            //添加指令列
            _sv = fpSpread1.Sheets[0];
            var delBtn = new FarPoint.Win.Spread.CellType.ButtonCellType { Text = "删除" };
            var updateBtn = new FarPoint.Win.Spread.CellType.ButtonCellType { Text = "更新" };

            _sv.AddColumns(9, 2);
            _sv.Columns[9].CellType = delBtn;
            _sv.Columns[10].CellType = updateBtn;
            _sv.Columns[9].Label = "删除列";
            _sv.Columns[10].Label = "编辑列";
            fpSpread1.ButtonClicked += fpSpread1_ButtonClicked;
        }

    void fpSpread1_ButtonClicked(object sender, EditorNotifyEventArgs e)
        {
            bool isUpdate = e.EditingControl.Text=="更新"?true:false;

            if (isUpdate)
            {
                UpdateData();
            }
            else
            {
                DelData();
            }
        }

        private void DelData()
        {
            var cmd = new OleDbCommand();

            var dbcon = new OleDbConnection(ConnStr);
            dbcon.Open();

            var curRow = _sv.ActiveRowIndex;
            var pram = new OleDbParameter("订单ID", _sv.Cells[curRow, 0].Value);
            cmd.Parameters.Add(pram);
            cmd.Parameters[0].DbType = DbType.Int32;
            var sqlcommand = "DELETE FROM 订单 WHERE 订单ID=@订单ID";

            cmd.Connection = dbcon;
            cmd.CommandText = sqlcommand;

            var count = 0;

            try
            {
                count = cmd.ExecuteNonQuery();
                _sv.Rows.Remove(curRow, 1);
            }
            catch (Exception)
            {

            }
            finally
            {
                if (count >= 1)
                {
                    MessageBox.Show("删除数据成功");
                }
                dbcon.Close();
            }
        }

        private void UpdateData()
        {
            var cmd = new OleDbCommand();

            var dbcon = new OleDbConnection(ConnStr);
            dbcon.Open();

            var colCount = _sv.ColumnCount - 2;
            var curRow = _sv.ActiveRowIndex;

            //通过列头文本设置参数
            for (var i = colCount-1; i >= 0; i--)
            {
                var pram = new OleDbParameter(_sv.Columns[i].Label, _sv.Cells[curRow, i].Value);
                cmd.Parameters.Add(pram);
            }

            //设置参数类型
            cmd.Parameters[0].DbType = DbType.String;
            cmd.Parameters[1].DbType = DbType.String;
            cmd.Parameters[2].DbType = DbType.String;
            cmd.Parameters[3].DbType = DbType.String;
            cmd.Parameters[4].DbType = DbType.Currency;
            cmd.Parameters[5].DbType = DbType.Int32;
            cmd.Parameters[6].DbType = DbType.DateTime;
            cmd.Parameters[7].DbType = DbType.String;
            cmd.Parameters[8].DbType = DbType.Int32;

            const string sqlcommand = "UPDATE 订单 SET 货主国家=@货主国家,货主城市=@货主城市,货主地址=@货主地址,货主名称=@货主名称,运货费=@运货费,运货商=@运货商,订购日期=@订购日期,客户ID=@客户ID WHERE 订单ID=@订单ID";

            cmd.Connection = dbcon;
            cmd.CommandText = sqlcommand;
            var count = 0;

            try
            {
                count = cmd.ExecuteNonQuery();
            }
            catch (Exception)
            {

            }
            finally
            {
                if (count >= 1)
                {
                    MessageBox.Show("修改数据成功");
                }
                dbcon.Close();
            }
        }


    }
}