﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Spread_Win_DataSource
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
            this.WindowState = FormWindowState.Maximized;

            ClearMdiChildren();
            BindBySmartTag smartForm = new BindBySmartTag();
            smartForm.MdiParent = this;
            smartForm.Dock = DockStyle.Fill;
            smartForm.WindowState = FormWindowState.Maximized;
            smartForm.Show();
        }

        private void 通过SmartTag绑定数据ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ClearMdiChildren();
            BindBySmartTag smartForm = new BindBySmartTag();
            smartForm.MdiParent = this;
            smartForm.Dock = DockStyle.Fill;
            smartForm.WindowState = FormWindowState.Maximized;
            smartForm.Show();
        }

        private void 指定绑定数据列ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ClearMdiChildren();
            var bindColumnForm = new BindColumn();
            bindColumnForm.MdiParent = this;
            bindColumnForm.Dock = DockStyle.Fill;
            bindColumnForm.WindowState = FormWindowState.Maximized;
            bindColumnForm.Show();
        }

        private void 区域绑定数据ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ClearMdiChildren();
            var bindCellRangeForm = new BindCellRange();
            bindCellRangeForm.MdiParent = this;
            bindCellRangeForm.Dock = DockStyle.Fill;
            bindCellRangeForm.WindowState = FormWindowState.Maximized;
            bindCellRangeForm.Show();
        }

        private void 数据库交互ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ClearMdiChildren();
            var handleDataForm = new HandleData();
            handleDataForm.MdiParent = this;
            handleDataForm.Dock = DockStyle.Fill;
            handleDataForm.WindowState = FormWindowState.Maximized;
            handleDataForm.Show();
        }

        public void ClearMdiChildren()
        {
            int mdiChildrenCount = this.MdiChildren.Length;
            for (int i = 0; i < mdiChildrenCount; i++)
            {
                this.MdiChildren[i].Close();
            }
        }
    }
}
